import numpy as np
import pylab as pl
import math
import scipy as sp
from scipy import linalg,random

def f1(x,y):
    return 2*x**2+3*x+y**2-2

def f2(x,y):
    return y**2-2*y+x**2+1
    
    
def f3(x):
    return x**4-7*x+8

def f3p(x):
    return 4*x**3-7

def f1b(x):
    return 2*x[0]**2+3*x[0]+x[1]**2-2

def df1b(x):
    return np.array([4*x[0]+3,2*x[1]])

def f2b(x):
    return x[1]**2-2*x[1]+x[0]**2+1

def df2b(x):
    return np.array([2*x[0],2*x[1]-2])

def gc(x,c):
    return x**2-c

def g(x,y):
    return x**2-y

def jK(x):
    return np.max(x[0]**2+x[1]**2-1,0)+np.max(1-x[0]-x[1],0)

def jK2(x):
    return (np.max(x[0]**2+x[1]**2-1,0)+np.max(1-x[0]-x[1],0))**2

def djK(x):
    u=x[0]**2+x[1]**2-1
    v=1-x[0]-x[1]
    w=1+np.sign(u)
    t=(np.sign(v)+1)/2
    return jK(x)*np.array([x[0]*w-t,x[1]*w-t])

def dg(x):
    z=x.copy()
    z[0]=2*x[0]
    z[1]=-1
    return z

def ga(x):
    return x[0]**2-x[1]

def gaa(x):
    c1=np.array([x[0]**2+x[1]**2-1,1-x[0]-x[1]])
    c=np.max([c1,0*x],0)
    return sp.linalg.norm(c)**2

def dga(x):
    c1=np.array([x[0]**2+x[1]**2-1,1-x[0]-x[1]])
    c=np.max([c1,0*x],0)
    #r1=4*np.max(x[0]**2+x[1]**2-1,0)*np.array([x[0],x[1]])
    #r2=2*np.max(1-x[0]-x[1],0)*np.ones(2)
    return 4*c[0]*np.array([x[0],x[1]]) -2*c[1]*np.ones(2)



def projK(x):
    y=x.copy()
    x1=x[0]
    x2=x[1]
    s=(x1-x2)/np.sqrt(2)
    t=(x1+x2)/np.sqrt(2)
    r=s**2+t**2
    if r <= 1 and t >= 1/np.sqrt(2):
        s1=s
        t1=t
    if t >= abs(t) and r >= 1:
        s1=s/np.sqrt(r)
        t1=t/np.sqrt(r)
    if t <= 1/np.sqrt(2) and abs(s) <= 1/np.sqrt(2):
        s1=s
        t1=1/np.sqrt(2)
    if t <= abs(s):
        if s >= 1/np.sqrt(2):
            s1=1/np.sqrt(2)
            t1=s1
        if s <= -1/np.sqrt(2):
            s1=-1/np.sqrt(2)
            t1=s1
    y[0]=(s1+t1)/np.sqrt(2)
    y[1]=(t1-s1)/np.sqrt(2)
    return y


def f4(x):
    pi=4*math.atan(1)
    r=0.5+math.atan(x[0])/pi
    xx=3*(1+r*np.cos(x[1]))/2
    y=2*r*np.sin(x[1])
    u=(3-np.sqrt(xx**2+y**2))**2
    u+=(2-np.sqrt((xx-3)**2+y**2))**2/2
    return u

def df4(x):
    pi=4*math.atan(1)
    r=0.5+math.atan(x[0])/pi
    xx=3*(1+r*np.cos(x[1]))/2
    y=2*r*np.sin(x[1])
    r1=np.sqrt(xx**2+y**2)
    r2=np.sqrt((xx-3)**2+y**2)
    v1=2*xx-3-3*xx/r1+2*(3-xx)/r2
    v2=3*y-6*y/r1-2*y/r2
    c=1/(1+x[0]**2)/pi
    w1=(3*v1*np.cos(x[1])/2+2*v2*np.sin(x[1]))*c
    w2=-3*r*v1*np.sin(x[1])/2+2*r*v2*np.cos(x[1])
    return np.array([w1,w2])

