/////////////// library.sci: //////////

function z=f1(x,y)

z=2*x.^2+3*x+y.^2-2;

endfunction

function z=f2(x,y)
z=y.^2-2*y+x.^2+1;

endfunction


function y=f3(x)

y=x.^4-7*x+8;
endfunction

function y=f3p(x)

y=4*x.^3-7;

endfunction


function z=fK1(x)

z=x(1)^2+x(2)^2-1;


endfunction



function z=fK2(x)

z=1-x(1)-x(2);

endfunction

function z=fK(x)

z1=max(fK1(x),0);
z2=max(fK2(x),0);
z=z1*z2;

endfunction


function z=dg(x)
z(1)=2*x(1);
z(2)=-1;
endfunction


function z=g(x)

z=x(1)^2-x(2);

endfunction

function y=gK(x)

y=0;

if (fK(x)>0)
y=g(x);
end

endfunction

function z=dgK(x)

z=0;

if (fK(x)>0)
  z=dg(x);
end

endfunction


function y=projK(x)

y=x;

x1=x(1);
x2=x(2);

s=x1+x2;

if s==1 then
  if x2>1
     y(1)=0;
     y(2)=1;
  else 
     if x2<0
        y(1)=1;
        y(2)=0;
     end 
   end
end

if s>1 
   y=x/norm(x);
end

if s<1
   y(1)=(1+x1-x2)/2;
   y(2)=(1-x1+x2)/2;
end
   

endfunction



///////// Exo 4: ///////

function u=f4(x)

a=x(1);
theta=x(2);



r=0.5+atan(a)/%pi;

x=3*(1+r.*cos(theta))/2;
y=2*r.*sin(theta);

u=(3-sqrt(x.^2+y.^2)).^2;
u=u+(2-sqrt((x-3).^2+y.^2)).^2/2;

endfunction

function v=df4(x)

a=x(1);
theta=x(2);

r=0.5+atan(a)/%pi;

x=3*(1+r.*cos(theta))/2;
y=2*r.*sin(theta);

r1=sqrt(x.^2+y.^2);
r2=sqrt((3-x).^2+y.^2);
v1=2*x-3;
v1=v1-3*x./r1;
v1=v1+2*(3-x)./r2;
v2=3*y-6*y./r1-2*y./r2;
w1=3*v1.*cos(theta)/2+2*v2.*sin(theta);
w1=w1/(1+a.^2)/%pi;
w2=-3*r.*v1.*sin(theta)/2+2*r.*v2.*cos(theta);
v=[w1;w2];
endfunction
