//////// methodes.sci: //////////
// exec methodes.sci

function u=gradopt(A,b,u0,iter)

u=u0;

for i=1:iter
r=b-A*u;
lambda=-r'*r/(r'*A*r);
u=u+lambda*r;
end

endfunction

function [tabu,taberr,iter]=gradfix_eps(A,b,u0,rho,eps)

tabu=[u0];


u=u0;r=b-A*u;
test=norm(r);
taberr=[test];
iter=0;

itmax=20;

while (test>eps)&(iter<itmax)


u=u+rho*r;
r=b-A*u;
test=norm(r);
iter=iter+1;
tabu=[tabu,u];
taberr=[taberr,test];
end



endfunction



function [tabu,taberr,iter]=gradopt_eps(A,b,u0,eps)

tabu=[u0];


u=u0;r=b-A*u;
test=norm(r);
taberr=[test];
iter=0;

itmax=10;

while (test>eps)&(iter<itmax)

lambda=-r'*r/(r'*A*r);
u=u-lambda*r;
r=b-A*u;
test=norm(r);
iter=iter+1;
tabu=[tabu,u];
taberr=[taberr,test];
end




endfunction





function [tabx,taberr]=gradfi(fp,x0,rho,eps)

tabx=[];
taberr=[];

itmax=100;
iter=0;
pas=fp(x0);
err=abs(pas);
x1=x0;

while (err>eps)&(iter<itmax)
x=x1;
tabx=[tabx,x];
taberr=[taberr,err];

x1=x-rho*pas;
pas=fp(x1);
err=abs(pas);
iter=iter+1;
end


endfunction


function [tabx,taberr,taber]=gradfiproj(df,x0,rho,eps)

tabx=[];
taberr=[];
taber=[];

itmax=20;
iter=0;

x=x0;
x1=projK(x-rho*df(x));

err=norm(x1-x);

taberr=[err];
tabx=[x];
iter=1;

while(err>eps)&(iter<itmax)
x=x1;
x1=projK(x-rho*df(x));
err=norm(x1-x);
iter=iter+1;
taberr=[taberr,err];
tabx=[tabx,x];

end



for i=1:iter
taber=[taber,norm(tabx(:,i)-x)];
end


endfunction


function [tabx,tabx2]=gradfip(df,x0,rho,eps)

tabx=[];
taberr=[];
taber=[];

itmax=20;
iter=0;

x=x0;
x2=x-rho*df(x)
x1=projK(x2);

err=norm(x1-x);

taberr=[err];
tabx=[x];
tabx2=[x2];
iter=1;

while(err>eps)&(iter<itmax)
x=x1;
x2=x-rho*df(x);
x1=projK(x2);
err=norm(x1-x);
iter=iter+1;
taberr=[taberr,err];
tabx=[tabx,x];
tabx2=[tabx2,x2];

end



for i=1:iter
taber=[taber,norm(tabx(:,i)-x)];
end


endfunction





function [tabx,taberr,taber]=gradfipe(df,df0,x0,rho,eps,param)

tabx=[];
taberr=[];
taber=[];

itmax=20;
iter=0;

x=x0;
x2=x-rho*(df(x)+df0(x)/param);
x1=projK(x2);

err=norm(x1-x);

taberr=[err];
tabx=[x];
tabx2=[x2];
iter=1;

while(err>eps)&(iter<itmax)
x=x1;
x2=x-rho*(df(x)+df0(x)/param);
x1=projK(x2);
err=norm(x1-x);
iter=iter+1;
taberr=[taberr,err];
tabx=[tabx,x];
tabx2=[tabx2,x2];

end



for i=1:iter
taber=[taber,norm(tabx(:,i)-x)];
end


endfunction


function [tabx,taberr]=gradfi2(fp,x0,rho,eps)

tabx=[];
taberr=[];

itmax=100;
iter=0;
pas=fp(x0);
err=norm(pas);
x1=x0;

while (err>eps)&(iter<itmax)
x=x1;
tabx=[tabx,x];
taberr=[taberr,err];

x1=x-rho*pas;
pas=fp(x1);
err=norm(pas);
iter=iter+1;
end


endfunction




